install_policy.sh 2.25 KB
Newer Older
1
#!/bin/sh
2
# SPDX-License-Identifier: GPL-2.0
3
set -e
4 5 6 7
if [ `id -u` -ne 0 ]; then
	echo "$0: must be root to install the selinux policy"
	exit 1
fi
8

9 10
SF=`which setfiles`
if [ $? -eq 1 ]; then
11 12 13
	echo "Could not find setfiles"
	echo "Do you have policycoreutils installed?"
	exit 1
14 15 16
fi

CP=`which checkpolicy`
17 18 19 20 21
if [ $? -eq 1 ]; then
	echo "Could not find checkpolicy"
	echo "Do you have checkpolicy installed?"
	exit 1
fi
22 23
VERS=`$CP -V | awk '{print $1}'`

24 25 26 27 28 29 30 31 32 33
ENABLED=`which selinuxenabled`
if [ $? -eq 1 ]; then
	echo "Could not find selinuxenabled"
	echo "Do you have libselinux-utils installed?"
	exit 1
fi

if selinuxenabled; then
    echo "SELinux is already enabled"
    echo "This prevents safely relabeling all files."
34
    echo "Boot with selinux=0 on the kernel command-line."
35 36 37 38 39 40
    exit 1
fi

cd mdp
./mdp -m policy.conf file_contexts
$CP -U allow -M -o policy.$VERS policy.conf
41 42 43 44

mkdir -p /etc/selinux/dummy/policy
mkdir -p /etc/selinux/dummy/contexts/files

45 46 47 48 49 50 51 52 53 54 55 56 57
echo "__default__:user_u:s0" > /etc/selinux/dummy/seusers
echo "base_r:base_t:s0" > /etc/selinux/dummy/contexts/failsafe_context
echo "base_r:base_t:s0 base_r:base_t:s0" > /etc/selinux/dummy/default_contexts
cat > /etc/selinux/dummy/contexts/x_contexts <<EOF
client * user_u:base_r:base_t:s0
property * user_u:object_r:base_t:s0
extension * user_u:object_r:base_t:s0
selection * user_u:object_r:base_t:s0
event * user_u:object_r:base_t:s0
EOF
touch /etc/selinux/dummy/contexts/virtual_domain_context
touch /etc/selinux/dummy/contexts/virtual_image_context

58 59 60 61 62 63 64 65
cp file_contexts /etc/selinux/dummy/contexts/files
cp dbus_contexts /etc/selinux/dummy/contexts
cp policy.$VERS /etc/selinux/dummy/policy
FC_FILE=/etc/selinux/dummy/contexts/files/file_contexts

if [ ! -d /etc/selinux ]; then
	mkdir -p /etc/selinux
fi
66 67 68 69 70 71 72
if [ -f /etc/selinux/config ]; then
    echo "/etc/selinux/config exists, moving to /etc/selinux/config.bak."
    mv /etc/selinux/config /etc/selinux/config.bak
fi
echo "Creating new /etc/selinux/config for dummy policy."
cat > /etc/selinux/config << EOF
SELINUX=permissive
73 74 75 76
SELINUXTYPE=dummy
EOF

cd /etc/selinux/dummy/contexts/files
77
$SF -F file_contexts /
78

79
mounts=`cat /proc/$$/mounts | \
80
	grep -E "ext[234]|jfs|xfs|reiserfs|jffs2|gfs2|btrfs|f2fs|ocfs2" | \
81 82
	awk '{ print $2 '}`
$SF -F file_contexts $mounts
83

84
echo "-F" > /.autorelabel